Attribute VB_Name = "DevInfo"
Option Explicit

#If Win32 Then
    Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
#Else
    Declare Function GetDeviceCaps Lib "GDI" (ByVal hdc As Integer, ByVal nIndex As Integer) As Integer
#End If

Public Const TECHNOLOGY = 2     ' Device type.
Public Const RASTERCAPS = 38    ' Raster capabilities.
Public Const NUMRESERVED = 106  ' # reserved entries in palette.
Public Const SIZEPALETTE = 104  ' Size of system palette.
Public Const HORZSIZE = 4       ' Horizontal size in millimeters.
Public Const VERTSIZE = 6       ' Vertical size in millimeters.
Public Const HORZRES = 8        ' Horizontal width in pixels.
Public Const VERTRES = 10       ' Vertical width in pixels.
Public Const LOGPIXELSX = 88    ' Logical pixels/inch horizontally.
Public Const LOGPIXELSY = 90    ' Logical pixels/inch horizontally.
Public Const BITSPIXEL = 12     ' # bits per pixel.
Public Const PLANES = 14        ' # color planes.
Public Const NUMBRUSHES = 16    ' # brushes.
Public Const NUMCOLORS = 24     ' # colors in device color table.
Public Const NUMFONTS = 22      ' # fonts.
Public Const NUMMARKERS = 20    ' # markers.
Public Const NUMPENS = 18       ' # pens.
Public Const COLORRES = 108     ' Color resolution.
Public Const CURVECAPS = 28     ' Curve capabilities.
Public Const LINECAPS = 30      ' Line capabilities.
Public Const POLYGONALCAPS = 32 ' Polygon capabilities.
Public Const TEXTCAPS = 34      ' Text capabilities.

' TECHNOLOGY values.
Public Const DT_PLOTTER = 0     ' Vector plotter.
Public Const DT_RASDISPLAY = 1  ' Raster display.
Public Const DT_RASPRINTER = 2  ' Raster printer.
Public Const DT_RASCAMERA = 3   ' Raster camera.
Public Const DT_CHARSTREAM = 4  ' Character-stream, PLP.
Public Const DT_METAFILE = 5    ' Metafile, VDM.
Public Const DT_DISPFILE = 6    ' Display-file.

' RASTERCAPS values.
Public Const RC_BITBLT = 1          ' Can BLT.
Public Const RC_BANDING = 2         ' Supports banding support.
Public Const RC_SCALING = 4         ' Supports scaling support.
Public Const RC_BITMAP64 = 8        ' Supports >64K bitmaps.
Public Const RC_GDI20_OUTPUT = &H10 ' Has 2.0 output calls.
Public Const RC_DI_BITMAP = &H80    ' Supports DIB to memory.
Public Const RC_PALETTE = &H100     ' Supports palettes.
Public Const RC_DIBTODEV = &H200    ' Supports DIBitsToDevice.
Public Const RC_BIGFONT = &H400     ' Supports >64K fonts.
Public Const RC_STRETCHBLT = &H800  ' Supports StretchBlt.
Public Const RC_FLOODFILL = &H1000  ' Supports FloodFill.
Public Const RC_STRETCHDIB = &H2000 ' Supports StretchDIBits.

' CURVECAP values.
Public Const CC_CHORD = 4       ' Chords.
Public Const CC_CIRCLES = 1     ' Circles.
Public Const CC_ELLIPSES = 8    ' Ellipses.
Public Const CC_INTERIORS = 128 ' Can do interiors.
Public Const CC_PIE = 2         ' Pie slices.
Public Const CC_STYLED = 32     ' Styled lines.
Public Const CC_WIDE = 16       ' Wide lines.
Public Const CC_WIDESTYLED = 64 ' Wide styled lines.

' LINECAPS values.
Public Const LC_INTERIORS = 128 ' Interiors.
Public Const LC_MARKER = 4      ' Markers.
Public Const LC_POLYLINE = 2    ' Polylines.
Public Const LC_POLYMARKER = 8  ' Polymarkers.
Public Const LC_STYLED = 32     ' Styled lines.
Public Const LC_WIDE = 16       ' Wide lines.
Public Const LC_WIDESTYLED = 64 ' Wide styled lines.

' POLYGONCAPS values.
Public Const PC_INTERIORS = 128 ' Interiors.
Public Const PC_POLYGON = 1     ' Alternate filled polygons.
Public Const PC_RECTANGLE = 2   ' Rectangles.
Public Const PC_SCANLINE = 8    ' Scanlines.
Public Const PC_STYLED = 32     ' Styled borders.
Public Const PC_WIDE = 16       ' Wide borders.
Public Const PC_WIDESTYLED = 64 ' Wide styled borders.
Public Const PC_WINDPOLYGON = 4 ' Winding number filled polygons.

' TEXTCAPS values.
Public Const TC_CP_STROKE = &H4     ' Stroke clip precision.
Public Const TC_CR_90 = &H8         ' Characters rotated 90 degrees.
Public Const TC_CR_ANY = &H10       ' Characters rotated by any angle.
Public Const TC_EA_DOUBLE = &H200   ' Bold.
Public Const TC_IA_ABLE = &H400     ' Italics.
Public Const TC_OP_CHARACTER = &H1  ' Character output precision.
Public Const TC_OP_STROKE = &H2     ' Stroke output precision.
Public Const TC_RA_ABLE = &H2000    ' Raster fonts.
Public Const TC_SA_CONTIN = &H100   ' Continuously scaled fonts.
Public Const TC_SA_DOUBLE = &H40    ' Fonts scaled by a double.
Public Const TC_SA_INTEGER = &H80   ' Fonts scaled by an integer.
Public Const TC_SF_X_YINDEP = &H20  ' Fonts scaled in the X and Y directions independently.
Public Const TC_SO_ABLE = &H1000    ' Strikeout.
Public Const TC_UA_ABLE = &H800     ' Underline.
Public Const TC_VA_ABLE = &H4000    ' Vector fonts.

