VERSION 4.00
Begin VB.Form CompositeForm 
   Caption         =   "Composite"
   ClientHeight    =   5895
   ClientLeft      =   1215
   ClientTop       =   585
   ClientWidth     =   6510
   Height          =   6300
   Left            =   1155
   LinkTopic       =   "Form1"
   ScaleHeight     =   393
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   434
   Top             =   240
   Width           =   6630
   Begin VB.PictureBox DestPict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   375
      Left            =   6120
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   21
      TabIndex        =   7
      Top             =   1440
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.PictureBox Mask2Pict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   375
      Left            =   6120
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   21
      TabIndex        =   6
      Top             =   960
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.PictureBox Mask1Pict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   375
      Left            =   6120
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   21
      TabIndex        =   5
      Top             =   480
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.PictureBox SourcePict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   375
      Left            =   6120
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   21
      TabIndex        =   4
      Top             =   0
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.PictureBox DisplaySwin 
      Height          =   5655
      Left            =   0
      ScaleHeight     =   373
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   413
      TabIndex        =   2
      Top             =   0
      Width           =   6255
      Begin VB.PictureBox DisplayPict 
         AutoRedraw      =   -1  'True
         Height          =   5535
         Left            =   0
         Picture         =   "COMPOSE.frx":0000
         ScaleHeight     =   365
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   405
         TabIndex        =   3
         Top             =   0
         Width           =   6135
      End
   End
   Begin VB.HScrollBar DisplayHBar 
      Enabled         =   0   'False
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   5640
      Width           =   6285
   End
   Begin VB.VScrollBar DisplayVBar 
      Enabled         =   0   'False
      Height          =   5655
      Left            =   6240
      TabIndex        =   0
      Top             =   0
      Width           =   255
   End
End
Attribute VB_Name = "CompositeForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim SysPalSize As Integer
Dim NumStaticColors As Integer
Dim StaticColor1 As Integer
Dim StaticColor2 As Integer

Dim bytes_source() As Byte
Dim bytes_dest() As Byte
Dim bytes_mask1() As Byte
Dim bytes_mask2() As Byte
Dim wid(0 To 3) As Long
Dim hgt(0 To 3) As Long
Dim palentry(0 To 255) As PALETTEENTRY

' ************************************************
' Create and display the composite image.
' ************************************************
Public Sub MakeComposite(xoff As Integer, yoff As Integer)
Dim xmin As Integer
Dim ymin As Integer
Dim xmax As Integer
Dim ymax As Integer
Dim x As Integer
Dim y As Integer
Dim black As Integer
Dim white As Integer
Dim status As Long

    WaitStart
    
    SourcePict.Visible = False
    DestPict.Visible = False
    Mask1Pict.Visible = False
    Mask2Pict.Visible = False
    
    ' See where source and destination overlap.
    xmin = 1 + xoff
    If xmin < 1 Then xmin = 1
    ymin = 1 + yoff
    If ymin < 1 Then ymin = 1
    xmax = wid(0) + xoff
    If xmax > wid(1) Then xmax = wid(1)
    ymax = hgt(0) + yoff
    If ymax > hgt(1) Then ymax = hgt(1)
    
    ' Overlay the source on the destination over
    ' pixels where the source mask is black and
    ' the destination mask is white.
    black = StaticColor1 + 1
    white = StaticColor2 - 1
    For y = ymin To ymax
        For x = xmin To xmax
            If bytes_mask2(x, y) = white And _
               bytes_mask1(x - xoff, y - yoff) = black Then
                bytes_dest(x, y) = bytes_source(x - xoff, y - yoff)
            End If
        Next x
    Next y

    DisplayPict.Move 0, 0, DestPict.Width, DestPict.Height
    DoEvents
    status = SetBitmapBits(DisplayPict.Image, wid(1) * hgt(1), bytes_dest(1, 1))
    DisplayPict.Refresh
    DisplayPict.Picture = DisplayPict.Image

    ResetScrollBars
    
    WaitEnd
End Sub

' ************************************************
' Return the index of the nonstatic gray closest
' to the given value (assuming the non-static
' colors are a gray scale created by
' MatchGrayPalette).
' ************************************************
Function NearestNonstaticGray(c As Integer) As Integer
Dim dgray As Single

    If c < 0 Then
        c = 0
    ElseIf c > 255 Then
        c = 255
    End If
    dgray = 255 / (StaticColor2 - StaticColor1 - 2)
    NearestNonstaticGray = c / dgray + StaticColor1 + 1
End Function




' ***********************************************
' Load the indicated file and prepare to work
' with its palette.
' ***********************************************
Public Sub LoadFiles(source_name As String, dest_name As String, mask1_name As String, mask2_name As String)
Dim fname As String
Dim i As Integer

    WaitStart
    
    ' Create DisplayPict's palette.
    MatchGrayPalette 0, DisplayPict, bytes_source
    DoEvents    ' Don't be a total CPU hog.

    ' Load the source file.
    fname = source_name
    SourcePict.Move 0, 0
    SourcePict.Visible = True
    On Error GoTo LoadFileError
    SourcePict.Picture = LoadPicture(fname)
    On Error GoTo 0
    MatchGrayPalette 0, SourcePict, bytes_source
    DoEvents    ' Don't be a total CPU hog.

    ' Load the destination file.
    fname = dest_name
    DestPict.Move 0, 0
    DestPict.Visible = True
    On Error GoTo LoadFileError
    DestPict.Picture = LoadPicture(fname)
    On Error GoTo 0
    MatchGrayPalette 1, DestPict, bytes_dest
    DoEvents    ' Don't be a total CPU hog.
    
    ' Load mask1.
    fname = mask1_name
    Mask1Pict.Move 0, 0
    Mask1Pict.Visible = True
    On Error GoTo LoadFileError
    Mask1Pict.Picture = LoadPicture(fname)
    On Error GoTo 0
    MatchGrayPalette 2, Mask1Pict, bytes_mask1
    DoEvents    ' Don't be a total CPU hog.
    
    ' Load mask2.
    fname = mask2_name
    Mask2Pict.Move 0, 0
    Mask2Pict.Visible = True
    On Error GoTo LoadFileError
    Mask2Pict.Picture = LoadPicture(fname)
    On Error GoTo 0
    MatchGrayPalette 3, Mask2Pict, bytes_mask2
    DoEvents    ' Don't be a total CPU hog.
    
    ' Rerealize each palette.
    SourcePict.ZOrder
    DoEvents
    DestPict.ZOrder
    DoEvents
    Mask1Pict.ZOrder
    DoEvents
    Mask2Pict.ZOrder
    DoEvents
    
    WaitEnd
    Exit Sub
    
LoadFileError:
    Beep
    MsgBox "Error loading file " & fname & "." & _
        vbCrLf & Error$
    WaitEnd
    Exit Sub
End Sub





' ***********************************************
' Load the control's palette so the non-static
' colors are grays. Map the logical palette to
' match the system palette. Convert the image to
' use the non-static grays.
'
' Set the following module global variables.
'   palentry()  Image logical palette entries.
'   wid         Width of image.
'   hgt         Height of image.
'   bytes(1 To wid, 1 To hgt)
'               Image pixel values.
' ***********************************************
Sub MatchGrayPalette(Index As Integer, pic As Control, bytes() As Byte)
Dim logpal As Integer
Dim sys(0 To 255) As PALETTEENTRY
Dim i As Integer
Dim bm As BITMAP
Dim hbm As Integer
Dim status As Long
Dim x As Integer
Dim y As Integer
Dim gray As Single
Dim dgray As Single
Dim c As Integer
Dim clr As Integer

    ' Make sure pic has the foreground palette.
    pic.ZOrder
    i = RealizePalette(pic.hdc)
    DoEvents

    ' Get the system palette entries.
    i = GetSystemPaletteEntries(pic.hdc, 0, SysPalSize, sys(0))
        
    ' Get the image pixels.
    hbm = pic.Image
    status = GetObject(hbm, BITMAP_SIZE, bm)
    wid(Index) = bm.bmWidthBytes
    hgt(Index) = bm.bmHeight
    ReDim bytes(1 To wid(Index), 1 To hgt(Index))
    status = GetBitmapBits(hbm, wid(Index) * hgt(Index), bytes(1, 1))
    
    ' Make the logical palette as big as possible.
    logpal = pic.Picture.hPal
    If ResizePalette(logpal, SysPalSize) = 0 Then
        Beep
        MsgBox "Error resizing logical palette.", _
            vbExclamation
        Exit Sub
    End If
    
    ' Blank the non-static colors.
    For i = 0 To StaticColor1
        palentry(i) = sys(i)
    Next i
    For i = StaticColor1 + 1 To StaticColor2 - 1
        With palentry(i)
            .peRed = 0
            .peGreen = 0
            .peBlue = 0
            .peFlags = PC_NOCOLLAPSE
        End With
    Next i
    For i = StaticColor2 To 255
        palentry(i) = sys(i)
    Next i
    i = SetPaletteEntries(logpal, 0, SysPalSize, palentry(0))

    ' Insert the non-static grays.
    gray = 0
    dgray = 255 / (StaticColor2 - StaticColor1 - 2)
    For i = StaticColor1 + 1 To StaticColor2 - 1
        c = gray
        gray = gray + dgray
        With palentry(i)
            .peRed = c
            .peGreen = c
            .peBlue = c
        End With
    Next i
    i = SetPaletteEntries(logpal, StaticColor1 + 1, StaticColor2 - StaticColor1 - 1, palentry(StaticColor1 + 1))

    ' Recreate the image using the new colors.
    For y = 1 To hgt(Index)
        For x = 1 To wid(Index)
            clr = bytes(x, y)
            With sys(clr)
                c = (CInt(.peRed) + .peGreen + .peBlue) / 3
            End With
            bytes(x, y) = NearestNonstaticGray(c)
        Next x
    Next y

    status = SetBitmapBits(hbm, wid(Index) * hgt(Index), bytes(1, 1))
    
    ' Realize the gray palette.
    i = RealizePalette(pic.hdc)
    
    pic.Refresh
End Sub



' ***********************************************
' Set the Max and LargeChange properties for the
' image scroll bars.
' ***********************************************
Sub ResetScrollBars()
    ' DisplayHBar.
    DisplayHBar.Value = 0
    If DisplaySwin.ScaleWidth >= DisplayPict.Width Then
        DisplayHBar.Enabled = False
    Else
        DisplayHBar.Max = DisplayPict.Width - DisplaySwin.ScaleWidth
        DisplayHBar.LargeChange = DisplaySwin.ScaleWidth
        DisplayHBar.Enabled = True
    End If
    
    ' DisplayVBar.
    DisplayVBar.Value = 0
    If DisplaySwin.ScaleHeight >= DisplayPict.Height Then
        DisplayVBar.Enabled = False
    Else
        DisplayVBar.Max = DisplayPict.Height - DisplaySwin.ScaleHeight
        DisplayVBar.LargeChange = DisplaySwin.ScaleHeight
        DisplayVBar.Enabled = True
    End If
End Sub



' ***********************************************
' Give the form and all the picture boxes an
' hourglass cursor.
' ***********************************************
Sub WaitStart()
    MousePointer = vbHourglass
    DisplayPict.MousePointer = vbHourglass
    SourcePict.MousePointer = vbHourglass
    DestPict.MousePointer = vbHourglass
    Mask1Pict.MousePointer = vbHourglass
    Mask2Pict.MousePointer = vbHourglass
    DoEvents
End Sub


' ***********************************************
' Restore the mouse pointers for the form and all
' the picture boxes.
' ***********************************************
Sub WaitEnd()
    MousePointer = vbDefault
    DisplayPict.MousePointer = vbDefault
    SourcePict.MousePointer = vbDefault
    DestPict.MousePointer = vbDefault
    Mask1Pict.MousePointer = vbDefault
    Mask2Pict.MousePointer = vbDefault
End Sub


Private Sub Form_Load()
    ' Make sure the screen supports palettes.
    If Not GetDeviceCaps(hdc, RASTERCAPS) And RC_PALETTE Then
        Beep
        MsgBox "This monitor does not support palettes.", _
            vbCritical
        End
    End If

    ' Get system palette size and # static colors.
    SysPalSize = GetDeviceCaps(hdc, SIZEPALETTE)
    NumStaticColors = GetDeviceCaps(hdc, NUMRESERVED)
    StaticColor1 = NumStaticColors \ 2 - 1
    StaticColor2 = SysPalSize - NumStaticColors \ 2
    
    ' Remove the borders from DisplayPict.
    DisplayPict.BorderStyle = vbTransparent
    SourcePict.BorderStyle = vbTransparent
    DestPict.BorderStyle = vbTransparent
    Mask1Pict.BorderStyle = vbTransparent
    Mask2Pict.BorderStyle = vbTransparent
End Sub

' ***********************************************
' Make the picture as large as possible.
' ***********************************************
Private Sub Form_Resize()
Dim hgt As Single
Dim wid As Single

    If WindowState = vbMinimized Then Exit Sub
        
    hgt = ScaleHeight - DisplayHBar.Height - 1
    wid = ScaleWidth - DisplayVBar.Width - 1
    
    ' Place the controls.
    DisplaySwin.Move 0, 0, wid, hgt
    DisplayVBar.Move _
        DisplaySwin.Left + DisplaySwin.Width + 1, _
        0, DisplayVBar.Width, hgt
    DisplayHBar.Move _
        DisplaySwin.Left, DisplaySwin.Height + 1, _
        wid
    
    ' Set the scroll bar limits.
    ResetScrollBars
End Sub

' ***********************************************
' Move DisplayPict within DisplaySwin.
' ***********************************************
Private Sub DisplayHBar_Change()
    DisplayPict.Left = -DisplayHBar.Value
End Sub

' ***********************************************
' Move DisplayPict within DisplaySwin.
' ***********************************************
Private Sub DisplayHBar_Scroll()
    DisplayPict.Left = -DisplayHBar.Value
End Sub




' ***********************************************
' Move DisplayPict within DisplaySwin.
' ***********************************************
Private Sub DisplayVBar_Change()
    DisplayPict.Top = -DisplayVBar.Value
End Sub


' ***********************************************
' Move DisplayPict within DisplaySwin.
' ***********************************************
Private Sub DisplayVBar_Scroll()
    DisplayPict.Top = -DisplayVBar.Value
End Sub



Private Sub Form_Unload(Cancel As Integer)
    End
End Sub


