VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ObjPolygon"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Public NumPoints As Integer
' Arrays are not allowed Public.
Private y() As Single
Private x() As Single

Function ObjectType() As String
    ObjectType = "POLYGON"
End Function


' ************************************************
' Compute the world coordinate bounds for the
' polygon.
' ************************************************
Sub Bound(xmin As Single, ymin As Single, xmax As Single, ymax As Single)
Dim i As Integer

    If NumPoints = 0 Then
        xmin = 0
        xmax = 0
        ymin = 0
        ymax = 0
        Exit Sub
    End If
    
    xmin = x(1)
    xmax = x(1)
    ymin = y(1)
    ymax = y(1)
    For i = 2 To NumPoints
        If x(i) < xmin Then xmin = x(i)
        If y(i) < ymin Then ymin = y(i)
        If x(i) > xmax Then xmax = x(i)
        If y(i) > ymax Then ymax = y(i)
    Next i
End Sub

' ************************************************
' Write a polygon to a file using Write.
' Begin with "POLYGON" to identify this object.
' ************************************************
Sub FileWrite(filenum As Integer)
Dim i As Integer

    Write #filenum, "POLYGON", NumPoints
    For i = 1 To NumPoints
        Write #filenum, x(i), y(i)
    Next i
End Sub
' ************************************************
' Draw the polygon on a Form, Printer, or
' PictureBox.
' ************************************************
Sub Draw(canvas As Object)
Dim i As Integer

    If NumPoints < 1 Then Exit Sub
    
    canvas.CurrentX = x(1)
    canvas.CurrentY = y(1)
    For i = 2 To NumPoints
        canvas.Line -(x(i), y(i))
    Next i
End Sub

' ************************************************
' Read a polygon from a file using Input.
' Assume the "POLYGON" label has already been read.
' ************************************************
Sub FileInput(filenum As Integer)
Dim i As Integer

    Input #filenum, NumPoints
    If NumPoints < 1 Then Exit Sub
    ReDim x(1 To NumPoints)
    ReDim y(1 To NumPoints)
    For i = 1 To NumPoints
        Input #filenum, x(i), y(i)
    Next i
End Sub

