VERSION 4.00
Begin VB.Form FlakeForm 
   Caption         =   "Snowflake"
   ClientHeight    =   4335
   ClientLeft      =   2280
   ClientTop       =   1185
   ClientWidth     =   5070
   Height          =   5025
   Left            =   2220
   LinkTopic       =   "Form1"
   ScaleHeight     =   289
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   338
   Top             =   555
   Width           =   5190
   Begin VB.TextBox LevelText 
      Height          =   285
      Left            =   600
      MaxLength       =   3
      TabIndex        =   0
      Text            =   "3"
      Top             =   0
      Width           =   375
   End
   Begin VB.PictureBox Canvas 
      AutoRedraw      =   -1  'True
      Height          =   4335
      Left            =   1080
      ScaleHeight     =   285
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   261
      TabIndex        =   3
      Top             =   0
      Width           =   3975
   End
   Begin VB.CommandButton CmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Level"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   495
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "FlakeForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Const PI = 3.14159

Dim TheLevel As Integer
Dim StartLength As Integer

' Coordinates of the points in the initiator.
Const NumIni = 3
Dim IniX(0 To NumIni) As Single
Dim IniY(0 To NumIni) As Single

' Angles and distances for the generator.
Const NumGen = 4
Dim DistFactor As Single
Dim GenDTheta(1 To NumGen) As Single


Sub GetParameters()
Dim theta As Single
    
    If Not IsNumeric(LevelText.Text) Then _
        LevelText.Text = "5"
    TheLevel = CInt(LevelText.Text)
End Sub

' ************************************************
' Initialize the generator.
' ************************************************
Sub InitGen(theta As Single)
    DistFactor = 1 / (2 * (1 + Cos(theta)))
    GenDTheta(1) = 0
    GenDTheta(2) = theta
    GenDTheta(3) = -2 * theta
    GenDTheta(4) = theta
End Sub

' ************************************************
' Recursively draw a snowflake edge starting at
' (x1, y1) in direction theta and distance dist.
' Leave the coordinates of the endpoint in
' (x1, y1).
' ************************************************
Sub DrawFlakeEdge(level As Integer, x1 As Single, y1 As Single, ByVal theta As Single, ByVal dist As Single)
Dim status As Integer
Dim i As Integer
Dim x2 As Single
Dim y2 As Single

    If level <= 0 Then
        x2 = x1 + dist * Cos(theta)
        y2 = y1 + dist * Sin(theta)
        Canvas.Line (x1, y1)-(x2, y2)
        x1 = x2
        y1 = y2
        Exit Sub
    End If
    
    ' Recursively draw the edge.
    dist = dist * DistFactor
    For i = 1 To NumGen
        theta = theta + GenDTheta(i)
        DrawFlakeEdge level - 1, x1, y1, theta, dist
    Next i
End Sub


Private Sub CmdGo_Click()
Const FRAMES_PER_SECOND = 20
Const DAngle = 2

Dim i As Integer
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single
Dim dx As Single
Dim dy As Single
Dim theta As Single
Dim angle As Single
Dim next_time As Long
Dim mspf As Long

    MousePointer = vbHourglass
    DoEvents

    ' Get the parameters.
    GetParameters
    
    ' Draw the snowflakes.
    next_time = GetTickCount()
    mspf = 1000 \ FRAMES_PER_SECOND ' ms per frame.
    For angle = 0 To 85 Step DAngle
        InitGen angle / 180 * PI
        WaitTill next_time
        Canvas.Cls
        For i = 1 To NumIni
            x1 = IniX(i - 1)
            y1 = IniY(i - 1)
            x2 = IniX(i)
            y2 = IniY(i)
            dx = x2 - x1
            dy = y2 - y1
            theta = Arctan2(dx, dy)
            DrawFlakeEdge TheLevel, x1, y1, _
                theta, StartLength
        Next i
        DoEvents
        next_time = next_time + mspf
    Next angle
    
    MousePointer = vbDefault
End Sub
Private Sub Form_Resize()
Dim unit As Single
Dim vunit As Single
Dim hunit As Single
Dim xmid As Single
Dim ymid As Single

    Canvas.Move Canvas.Left, 0, _
        ScaleWidth - Canvas.Left, ScaleHeight - 1

    ' See how big we can make the curve.
    vunit = 0.9 * Canvas.ScaleHeight / (Sqr(3) * 4 / 3)
    hunit = 0.9 * Canvas.ScaleWidth / 2
    If vunit < hunit Then
        unit = vunit
    Else
        unit = hunit
    End If
    StartLength = 2 * unit
    
    ' Initialize the initiator's coordinates.
    xmid = Canvas.ScaleWidth / 2
    ymid = Canvas.ScaleHeight / 2
    IniX(1) = xmid + unit
    IniY(1) = ymid - unit * Sqr(3) / 3
    IniX(2) = xmid - unit
    IniY(2) = IniY(1)
    IniX(3) = xmid
    IniY(3) = ymid + unit * Sqr(3) * 2 / 3
    IniX(0) = IniX(3)
    IniY(0) = IniY(3)
End Sub


Private Sub Form_Unload(Cancel As Integer)
    End
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


